-- name: [CS] Quad Squad V3.0
-- description: Hello, this CS has the function of bringing 4 Randoms to Co-opDX. These are the characters:\n-Eclipze, Mystic, Luxer and Klin\n\nThis Update incluides the following:\n-Redesigned Hud\n-All Characters Redesigned\n-and more!\n\nI hope you like the mod!\n\n-Credits- \nMysticG (Owner): Modeler and Artist, Made the sprites\nEclipze3 (Co-Owner): In charge of making the recolorable models and using blender\nKlinYT: Writer\nX Luxer: Emotional support
-- category: cs



if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local TEX_MYSTIC = get_texture_info("MS-icon")
local TEX_ECLIPZE = get_texture_info("EZE-icon")
local TEX_LUXER = get_texture_info("LAU-icon")
local TEX_KLIN = get_texture_info("KLIN-icon")

local TEXT_MOD_NAME = "Quad Squad"

local E_LUXER_MODEL = smlua_model_util_get_id("luxer_geo")
local E_MYSTIC_MODEL = smlua_model_util_get_id("mystic_geo")
local E_KLIN_MODEL = smlua_model_util_get_id("klin_geo")
local E_ECLIPZE_MODEL = smlua_model_util_get_id("eclipze_geo")


local VOICETABLE_CHAR = {
    [CHAR_SOUND_ATTACKED] = 'hit.ogg',
    [CHAR_SOUND_DOH] = 'silence.ogg',
    [CHAR_SOUND_DROWNING] = 'silence.ogg',
    [CHAR_SOUND_DYING] = 'silence.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'groundpound.ogg',
    [CHAR_SOUND_HAHA] = 'haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'haha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'silence.ogg',
    [CHAR_SOUND_HOOHOO] = 'jump2.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'mamamia.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'silence.ogg',
    [CHAR_SOUND_ON_FIRE] = 'fire.ogg',
    [CHAR_SOUND_OOOF] = 'hit.ogg',
    [CHAR_SOUND_OOOF2] = 'hit.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'silence.ogg',
    [CHAR_SOUND_WAH2] = 'silence.ogg',
    [CHAR_SOUND_WHOA] = 'silence.ogg',
    [CHAR_SOUND_YAHOO] = 'longjump.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'jump.ogg', 'jump2.ogg', 'jump3.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'jump.ogg', 'jump2.ogg', 'jump3.ogg'},
}

local HEALTH_METER_LUXER= {
    label = {
        left = get_texture_info("LUXER1"),
        right = get_texture_info("LUXER2"),
    },
    pie = {
        [1] = get_texture_info("hp-pie-1"),
        [2] = get_texture_info("hp-pie-2"),
        [3] = get_texture_info("hp-pie-3"),
        [4] = get_texture_info("hp-pie-4"),
        [5] = get_texture_info("hp-pie-5"),
        [6] = get_texture_info("hp-pie-6"),
        [7] = get_texture_info("hp-pie-7"),
        [8] = get_texture_info("hp-pie-8"),
    }
}


local HEALTH_METER_MYSTIC= {
    label = {
        left = get_texture_info("MYSTIC1"),
        right = get_texture_info("MYSTIC2"),
    },
    pie = {
        [1] = get_texture_info("hp-pie-1"),
        [2] = get_texture_info("hp-pie-2"),
        [3] = get_texture_info("hp-pie-3"),
        [4] = get_texture_info("hp-pie-4"),
        [5] = get_texture_info("hp-pie-5"),
        [6] = get_texture_info("hp-pie-6"),
        [7] = get_texture_info("hp-pie-7"),
        [8] = get_texture_info("hp-pie-8"),
    }
}

local HEALTH_METER_KLIN= {
    label = {
        left = get_texture_info("KLIN1"),
        right = get_texture_info("KLIN2"),
    },
    pie = {
        [1] = get_texture_info("hp-pie-1"),
        [2] = get_texture_info("hp-pie-2"),
        [3] = get_texture_info("hp-pie-3"),
        [4] = get_texture_info("hp-pie-4"),
        [5] = get_texture_info("hp-pie-5"),
        [6] = get_texture_info("hp-pie-6"),
        [7] = get_texture_info("hp-pie-7"),
        [8] = get_texture_info("hp-pie-8"),
    }
}

local HEALTH_METER_ECLIPZE= {
    label = {
        left = get_texture_info("ECLIPZE1"),
        right = get_texture_info("ECLIPZE2"),
    },
    pie = {
        [1] = get_texture_info("hp-pie-1"),
        [2] = get_texture_info("hp-pie-2"),
        [3] = get_texture_info("hp-pie-3"),
        [4] = get_texture_info("hp-pie-4"),
        [5] = get_texture_info("hp-pie-5"),
        [6] = get_texture_info("hp-pie-6"),
        [7] = get_texture_info("hp-pie-7"),
        [8] = get_texture_info("hp-pie-8"),
    }
}


local PALETTE_MYSTIC = {
    [PANTS]  = "292e2a",
    [SHIRT]  = "534e72",
    [GLOVES] = "ffffff",
    [SHOES]  = "534e72",
    [HAIR]   = "34547b",
    [SKIN]   = "fead9c",
    [CAP]    = "2c2c2c",
}

local PALETTE_LUXER = {
    [PANTS]  = "008cc6",
    [SHIRT]  = "383833",
    [GLOVES] = "ffffff",
    [SHOES]  = "34a83e",
    [HAIR]   = "f1da69",
    [SKIN]   = "ff9a55",
    [CAP]    = "2e2e2e",
}

local PALETTE_KLIN = {
    [PANTS]  = "b8c9ff",
    [SHIRT]  = "43adff",
    [GLOVES] = "ffc784",
    [SHOES]  = "008f6f",
    [HAIR]   = "f7e54c",
    [SKIN]   = "ffd89d",
    [CAP]    = "43adff",
}

local PALETTE_ECLIPZE = {
    [PANTS]  = "333333",
    [SHIRT]  = "b3b3b3",
    [GLOVES] = "333333",
    [SHOES]  = "b3b3b3",
    [HAIR]   = "333333",
    [SKIN]   = "ffa17d",
    [CAP]    = "b3b3b3",
}



local CSloaded = false
local function on_character_select_load()

    CT_ECLIPZE = _G.charSelect.character_add("Eclipze", {"Insane", "a stupid crazy and heavy guy team heat forever"}, "Mystic & Eclipze", {r = 250, g = 239, b = 14}, E_ECLIPZE_MODEL, CT_LUIGI, TEX_ECLIPZE)
    _G.charSelect.character_add_palette_preset(E_ECLIPZE_MODEL, PALETTE_ECLIPZE)
	_G.charSelect.character_add_voice(E_ECLIPZE_MODEL, VOICETABLE_CHAR)
	_G.charSelect.character_add_health_meter(CT_ECLIPZE, HEALTH_METER_ECLIPZE)
	
    CT_MYSTIC = _G.charSelect.character_add("Mystic", {"dumb", "A quiet and friendly guy, somewhat absent-minded."}, "Mystic & Eclipze", {r = 89, g = 105, b = 169}, E_MYSTIC_MODEL, CT_MARIO, TEX_MYSTIC)
    _G.charSelect.character_add_palette_preset(E_MYSTIC_MODEL, PALETTE_MYSTIC)
	_G.charSelect.character_add_voice(E_MYSTIC_MODEL, VOICETABLE_CHAR)
    _G.charSelect.character_add_health_meter(CT_MYSTIC, HEALTH_METER_MYSTIC)
	
	CT_LUXER = _G.charSelect.character_add("Luxer", {"Piromaniac", "He is a sick man who likes to set things on fire", "and he is quite stupid and he likes apples."}, "Mystic & Eclipze", {r = 120, g = 120, b = 120}, E_LUXER_MODEL, CT_MARIO, TEX_LUXER)
    _G.charSelect.character_add_palette_preset(E_LUXER_MODEL, PALETTE_LUXER)
	_G.charSelect.character_add_voice(E_LUXER_MODEL, VOICETABLE_CHAR)
    _G.charSelect.character_add_health_meter(CT_LUXER, HEALTH_METER_LUXER)
	
	CT_KLIN = _G.charSelect.character_add("Klin", {"Alex", "a random and calm boy who wears a blue star", "he likes to play retro games and he loves stars."}, "Mystic & Eclipze", {r = 67, g = 173, b = 255}, E_KLIN_MODEL, TOAD, TEX_KLIN)
    _G.charSelect.character_add_palette_preset(E_KLIN_MODEL, PALETTE_KLIN)
	_G.charSelect.character_add_voice(E_KLIN_MODEL, VOICETABLE_CHAR)
	_G.charSelect.character_add_health_meter(CT_KLIN, HEALTH_METER_KLIN)
	


    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAR then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAR then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)


--MESSAGE FROM MYSTIC: The truth is, I don't even know how I was able to do the CS

--MOMAZOS MICROFONO DEL GOBIERNO - Mystic

--laempanadadeclean - Klin

-- Yo viendo
-- Yo viendo con los ojos - Eclipze

--QUE ME MIRAS TE GUSTO GIL - X Luxer